<template>
  <div class="DataSource">
    <div id="datasource-outer-div">
      <h5>{{this.resourceName}}</h5>
    <b-container @dragenter="dragEnter" @dragleave="dragLeave" @dragend="dragLeave" @dragover.prevent="" @drop.prevent="uploadDrop">
      <div class="droppable" v-if="showDroppable"><p class="droppableText">{{ $t('canDropFile') }}</p></div>
      <b-row align-h="between">       
        <b-col md="6" align-self="start">
          <b-input-group>
            <b-button v-if="!downloadTrigger" class="leftButton" variant="primary" @click="upload">{{ $t('upload') }}</b-button>
            <b-button v-if="downloadTrigger" class="leftButton" variant="success" @click="download">{{ $t('download') }}</b-button>
          </b-input-group>
        </b-col>
        <b-col md="4" offset-md="2" align-self="end">
          <b-input-group>
            <b-form-input
              v-model="filter"
              type="search"
              id="filterInput"
              :placeholder="$t('typeToSearch')"
            ></b-form-input>
          </b-input-group>
        </b-col>
      </b-row>
      <br>
      <b-row>
        <b-col> 
          <b-table
            id="resourceViewTable"
            :fields="headers"
            :items="folder"
            :busy="isBusy"
            :locale="$i18n.locale"
            :filter="filter"
            :per-page="perPage"
            :current-page="currentPage"
            selectable
            striped
            bordered
            outlined
            hover          
            head-variant="dark"
            class="adaptTable"
            ref="adaptTable"
            @row-selected="onRowSelected"
          >
            <div slot="table-busy" class="text-center text-danger my-2">
              <b-spinner class="align-middle"></b-spinner>
              <strong style="margin-left: 1%;">{{ $t('loading') }}</strong>
            </div>
            <template v-slot:head(check)="row">
              <b-form-checkbox
                class="tableCheck"
                v-model="selectAll"
                @change="allSelect(row)"
              />
            </template>
            <template v-slot:cell(check)="row">
              <b-form-checkbox
                class="tableCheck"
                v-model="row.rowSelected"
                @change="select(row)"
              />
            </template>
            <template v-slot:cell(name)="row">
              <b-row>
                <b-col sm="1">
                  <i class="material-icons">
                    {{ row.item.isFolder ? 'folder' : 'insert_drive_file' }}
                  </i>
                </b-col>
                <b-col sm="11">
                  <a class="dataSourceItem" :href="'#' + row.item.absolutepath" @click="openDataSourceObject(row.item)">{{ row.item.name }}</a>
                </b-col>
              </b-row>
            </template>
            <template v-slot:cell(lastModified)="row">
              {{ renderDate(row) }}
            </template>
            <template v-slot:cell(actions)="row">
              <button type="button" class="btn btn-secondary" @click="openDetailView(row.item)" name="more">{{ $t('more') }}</button>
            </template>
            <template v-slot:empty="scope">
              <h4>{{ $t('tableIsEmpty') }}</h4>
            </template>
          </b-table>
        </b-col>   
      </b-row>
      <!--
        <b-row v-if="!isBusy && folder.length === 0">
          <b-col id="no-data">{{$t('noData')}}</b-col>
        </b-row>
      -->
      <b-row v-if="!isBusy && errorLoadingResource === true">
        <b-col class="center-align" id="error-loading-resource">{{$t('errorLoadingResource')}}</b-col>
      </b-row>
      <b-row>
        <b-col sm="2">
          <b-form-group
            :label="$t('perPage')"
            label-cols-sm="6"
            label-align-sm="right"
            label-size="sm"
            label-for="perPageSelect"
          >
            <b-form-select
              v-model="perPage"
              id="perPageSelect"
              size="sm"
              :options="pageOptions"
            ></b-form-select>
          </b-form-group>
        </b-col>
        <b-col offset-sm="7" sm="3">
          <b-pagination
            v-model="currentPage"
            :total-rows="folder.length"
            :per-page="perPage"
            aria-controls="resourceViewTable"
            size="sm"
            class="rightFloating"
          ></b-pagination>
        </b-col>     
      </b-row>
    </b-container>
    <DetailView :resourceId="resourceId" :applicationProfileId="applicationProfileId" :showDetail="showDetail" :uploadableFiles="uploadableFiles" :currentFolder="currentFolder" :editableFiles="editableFiles" :folder="folder" :fileInfo="fileInfo" :filesSelected="downloadTrigger"></DetailView>
  </div>
  </div>
</template>

<script lang="ts">
import Vue from 'vue';
import { ResourceApi, DataSourceApi, defaultOnCatch } from '@coscine/api-connection';
import DetailView from './DetailView.vue';

export default Vue.extend({
  name: 'DataSource',
  components: {
    DetailView,
  },
  mounted() {
    this.isBusy = true;
    if (this.isValidGuid(this.resourceId)) {
      ResourceApi.getResourceInformation(this.resourceId,
        (response: any) => {
          this.resourceName = response.data.displayName;
          this.applicationProfileId = response.data.applicationProfile;
          // Doesn't end with '/' => Probably a file
          if (this.currentFolder.indexOf('/', this.currentFolder.length - '/'.length) === -1) {
            // TODO: Change to open modal
            this.openDataSourceObject({
              isFolder: false,
              name: this.currentFolder.substring(this.currentFolder.lastIndexOf('/') + 1),
              absolutepath: this.currentFolder,
            });
            this.$set(this, 'currentFolder', this.currentFolder.substring(0, this.currentFolder.lastIndexOf('/') + 1));
          }
          const absolutePath = this.currentFolder;
          if (this.currentFolder !== '/') {
            let combine = '';
            const folderSplit = this.currentFolder.split('/');
            for (const folderKey in folderSplit) {
              if (folderSplit.hasOwnProperty(folderKey)) {
                const folder = folderSplit[folderKey];
                if (combine !== '' && folder === '') {
                  continue;
                }
                combine += folder + '/';
                this.folderPath.push(combine);
              }
            }
            this.folderPath.pop();
            if (this.folderPath.length > 0) {
              this.$set(this, 'currentFolder', this.folderPath.pop() as string);
            } else {
              this.$set(this, 'currentFolder', '');
            }
          } else {
            this.$set(this, 'currentFolder', '');
          }
          this.openDataSourceObject({
            isFolder: true,
            absolutepath: absolutePath,
          });
        },
        (error: any) => {
          this.errorLoadingResource = true;
          this.isBusy = false;
          defaultOnCatch(error);
        },
      );
    } else {
      this.errorLoadingResource = true;
      this.isBusy = false;
    }
  },
  data() {
    return {
      headers: [
        {
          key: 'check',
          sortable: false,
        },
        {
          label: this.$t('fileName'),
          key: 'name',
          sortable: true,
        },
        {
          label: this.$t('lastModified'),
          key: 'lastModified',
          sortable: true,
        },
        {
          label: this.$t('actions'),
          key: 'actions',
          sortable: false,
        },
      ],
      isBusy: true,
      selectAll: false,
      dragCounter: 0,
      downloadTrigger: false,
      showDroppable: false,
      currentPage: 1,
      filter: '',
      perPage: 50,
      pageOptions: [50, 100, 200],
      folder: [] as object[],
      currentFolder: (window.location.hash.indexOf('#') !== -1) ? window.location.hash.substring(1) : '/',
      folderPath: [] as string[],
      itemList: {},
      resourceName: '',
      applicationProfileId: '',
      fileInfo: {},
      showDetail: true,
      errorLoadingResource: false,
      editableFiles: [{ text: String, value: String }],
      selectableFiles: [{ text: String, value: String }],
      uploadableFiles: [] as object[],
    };
  },
  props: {
    resourceId: String,
  },
  methods: {
    openDataSourceObject(rowData: any) {
        if (rowData.isFolder === true) {
            this.isBusy = true;
            DataSourceApi.getDataSourceFolder(
                this.resourceId,
                rowData.absolutepath,
                (response: any) => {
                  this.folder = [];
                  if (rowData.name === '..') {
                      this.$set(this, 'currentFolder', this.folderPath.pop() as string);
                  } else if (this.currentFolder !== '') {
                      this.folderPath.push(this.currentFolder);
                      this.$set(this, 'currentFolder', rowData.absolutepath);
                  } else {
                      this.$set(this, 'currentFolder', rowData.absolutepath);
                  }
                  window.location.hash = this.currentFolder;
                  if (this.folderPath.length > 0) {
                      this.folder.push({
                          isFolder: true,
                          name: '..',
                          absolutepath: this.folderPath[this.folderPath.length - 1],
                      });
                  }
                  for (const obj of response.data.content) {
                      this.folder.push({
                          isFolder: obj.isFolder,
                          name: obj.name,
                          absolutepath: obj.absolutepath,
                          lastModified: (obj.lastModified !== null) ? obj.lastModified : obj.created,
                          created: obj.created,
                          size: obj.size,
                          content: obj.content,
                      });
                  }
                  this.isBusy = false;
                },
                defaultOnCatch,
            );
        } else {
            DataSourceApi.downloadDataSourceFile(
                this.resourceId,
                rowData.absolutepath,
                rowData.name,
                defaultOnCatch,
            );
        }
    },
    onRowSelected(items: []) {
      this.downloadTrigger = items.length > 0;
      this.selectAll = items.length === this.folder.length;
      this.selectableFiles = items;
    },
    isValidGuid(guid: any) {
      if (guid !== null && typeof guid === 'string' && guid.match(/[0-9A-F]{8}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{12}/i)) {
        return true;
      }
      return false;
    },
    allSelect(row: any) {
      if (!this.selectAll) {
        row.selectAllRows();
      } else {
        row.clearSelected();
      }
    },
    openDetailView(rowData: any) {
      this.showDetail = true;
      this.$set(this, 'fileInfo', rowData);
      this.editableFiles.length = 0;
      this.editableFiles.push({ text: rowData.name, value: rowData.absolutePath });
      this.$bvModal.show('detail-view');
    },
    select(row: any) {
      if (!row.rowSelected) {
        (this.$refs.adaptTable as any).selectRow(row.index);
      } else {
        (this.$refs.adaptTable as any).unselectRow(row.index);
      }
    },
    upload() {
      this.editableFiles.length = 0;
      this.showDetail = false;
      this.$bvModal.show('detail-view');
    },
    download() {
      this.showDetail = true;
      this.editableFiles.length = 0;
      for (const selectableFile of this.selectableFiles) {
        this.editableFiles.push({ text: (selectableFile as any).name, value: (selectableFile as any).absolutePath });
      }
      if (this.selectableFiles.length > 0) {
        this.$set(this, 'fileInfo', this.selectableFiles[0]);
      }
      this.$bvModal.show('detail-view');
    },
    dragEnter(ev: any) {
      this.dragCounter++;
      this.showDroppable = true;
    },
    dragLeave(ev: any) {
      this.dragCounter--;
      if (this.dragCounter === 0) {
        this.showDroppable = false;
      }
    },
    uploadDrop(ev: any) {
      this.dragCounter = 0;
      this.showDroppable = false;
      this.editableFiles.length = 0;
      this.uploadableFiles.length = 0;
      if (ev.dataTransfer.items) {
        for (const item of ev.dataTransfer.items) {
          if (item.kind === 'file') {
            const file = item.getAsFile();
            this.uploadableFiles.push(file);
          }
        }
        this.showDetail = false;
        this.$bvModal.show('detail-view');
      }
    },
    renderDate(row: any) {
      if (row.item.lastModified === null && row.item.created === null) {
        return '';
      }
      const date = row.item.lastModified;
      const dateObject = new Date(date);
      return dateObject.toLocaleDateString(this.$i18n.locale);
    },
  },
});
</script>

<style>
  #resourceViewTable td {
    vertical-align: middle;
  }
  #datasource-outer-div {
    border: 1px solid rgba(0,0,0,.125);
    border-radius: .2rem;
    padding: 1em;
  }
</style>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
  .center-align {
    text-align: center;
  }
  .droppable {
    cursor: pointer;
    position: fixed; /* Sit on top of the page content */
    width: 100%; /* Full width (cover the whole page) */
    height: 100%; /* Full height (cover the whole page) */
    top: 0;
    left: 0;
    right: 0;
    bottom: 0;
    background-color: rgba(0,0,0,0.5); /* Black background with opacity */
    z-index: 2; /* Specify a stack order in case you're using a different order for other elements */
    color: white;
    vertical-align: middle;
    text-align: center;
    font-size: 42pt;
  }
  .droppableText {    
    margin-top: 9em;
    margin-left: 4em;
  }
  .rightFloating {
    float: right;
  }
  .dataSourceItem {
    vertical-align: sub;
  }
  .tableCheck {
    text-align: center;
    margin-right: -0.5em;
  }
  .leftButton {
    height: calc(1.4em + .75rem + 2px);
  }
</style>
